/***************************************************************
 * class.c
 ***************************************************************/


#include "defns.i"
/* #include "types.i"*/
#include "class.h"
#include "extern.i"


/* I'm using Case[MaxAtt+1]._classes to store the classes */

int NumberOfMaskedClasses(Description Case, ClassList Classmask,int length)
{
  int i,total=0;
  for(i=0;i<length;i++) {
    if(Case[MaxAtt+1]._classes[i] && Classmask[i]) { total++; }
  }
  return total;
}

ClassList ClassesOf(Description Case)
{
  return Case[MaxAtt+1]._classes;
}

void InitialiseClassVal(Description Case)
{
  int i;

  ForEach(i,0,MaxClass)
    {
      Case[MaxAtt+1]._classes[i]=false;
    }
}


Boolean IsInHierClasses(Description Case, ClassNo c)
{
  ClassList classes = ClassesOf(Case);

  return (classes[c]);
}

/*
void SetClassHier(Description Case,int index)
{
  int parentindex;
  int maxtreesize = GetTreeSize(classTree);

  Case[MaxAtt+1]._classes[index] = true;
  parentindex = GetParentIndex(index,classTree);

  while(parentindex >= 0 && parentindex != maxtreesize)
    {
      if(Case[MaxAtt+1]._classes[parentindex] == true)
	{ parentindex = -1; }
      else {
	Case[MaxAtt+1]._classes[parentindex] = true;
	parentindex = GetParentIndex(parentindex,classTree);
      }
    }
}
*/

void SetClassHierBetter(Description Case, struct Classtree *class)
{
  struct Classtree * parent;
  int index, parentindex;
  int maxtreesize = GetTreeSize(classTree);

  
  index = GetIndexFromNode(class);
  Case[MaxAtt+1]._classes[index] = true;
  parent = class->parent;
  parentindex = GetIndexFromNode(parent);

  while(parentindex >= 0 && parentindex != maxtreesize)
    {
      if(Case[MaxAtt+1]._classes[parentindex] == true)
	{ parentindex = -1; }
      else {
	Case[MaxAtt+1]._classes[parentindex] = true;
	parent = parent->parent;
	parentindex = GetIndexFromNode(parent);
      }
    }
}

